#!/usr/bin/perl

use warnings;
use strict;
use English;
#use File::Basename;
#use File::Spec;
use IO::Handle;

#	open LOGFILE, '>', "/usr/bp/logs.dir/AgentUpgradeSambaInsert.log" or die $!;
	
	if (! -e "/usr/sbin/smbd")
	{
		print "AgentUpgradeSambaInsert: Samba daemon /usr/sbin/smbd does not exist\n";
	}

	`/usr/bp/bin/configure_smb status | grep -q "enabled"`;

	if ($? != 0)
	{
		print "AgentUpgradeSambaInsert: Samba not enabled.\n";
	}
	
	my $foundPrereqEntry = 0;
	my $foundWindowsEntry = 0;

	# Open samba config
	open SMBCONF, "</etc/samba/smb.conf";
	open SMBCONFNEW, ">>/etc/samba/smb.conf.agentupgradenew";
	while (<SMBCONF>) 
	{
		my($line) = $_;
		if(index($line, '[agent_prereq]') >= 0 )
		{
			print "AgentUpgradeSambaInsert: Entry agent_prereq already exists\n";
			$foundPrereqEntry = 1;
		}
		
		if(index($line, '[windows_agents]') >= 0 )
		{
			print "AgentUpgradeSambaInsert: Entry windows_agents already exists\n";
			$foundWindowsEntry = 1;
		}
		
		if(index($line, 'path = /backups/samba/agents/windows/') >= 0 )
		{
			print "AgentUpgradeSambaInsert: Updating windows_agents path.\n";
			print SMBCONFNEW "\tpath = /backups/AgentUpgrade/Agents/Windows/\n";
		}
		else
		{
			print SMBCONFNEW $_;
		}
	}
	
	if($foundPrereqEntry == 0)
	{
		print "AgentUpgradeSambaInsert: Adding agent_prereq entry to smb.conf\n";
		
		print SMBCONFNEW "\n[agent_prereq]\n";
		print SMBCONFNEW "\tpath = /backups/AgentUpgrade/WinReqScript/\n";
		print SMBCONFNEW "\tbrowseable = no\n";
		print SMBCONFNEW "\twritable = no\n";
		print SMBCONFNEW "\tguest ok = yes\n";
	}
	
	if($foundWindowsEntry == 0)
	{
		print "AgentUpgradeSambaInsert: Adding windows_agents entry to smb.conf\n";
		
		print SMBCONFNEW "\n[windows_agents]\n";
		print SMBCONFNEW "\tpath = /backups/AgentUpgrade/Agents/Windows/\n";
		print SMBCONFNEW "\tread only = yes\n";
		print SMBCONFNEW "\tguest ok = yes\n";
	}

	close SMBCONF;
	close SMBCONFNEW;
	
	rename "/etc/samba/smb.conf", "/etc/samba/smb.conf.agentupgradeold";
	if ($! != 0) {
		print "AgentUpgradeSambaInsert: Failed to rename smb.conf to smb.conf.agentupgradeold";
	}

	rename "/etc/samba/smb.conf.agentupgradenew", "/etc/samba/smb.conf";
	if ($! != 0) {
		print "AgentUpgradeSambaInsert: Failed to rename smb.conf.agentupgradenew to smb.conf";
	}

	`service smb restart >/dev/null 2>/dev/null`;
	if ($? != 0) {
		print "AgentUpgradeSambaInsert: service smb restart failed: $?\n";
	}
