#!/usr/bin/php
<?php

// get_default_device_info.php
// 040208	ME	4623
// This is a php CLI script, so it can be run from the commandline like this:
//    ./get_default_device_info.php [options...]
// (i.e., you don't run it like this: "php -f get_exchange_log.php [options...]")
// It has a usage message to tell you what should be on the commandline.
// 052908	ME	5229	determine if sync bit set for client.
// 060308	ME	5257	set elapsed_time in database for RRC display

$S_SUCCESSFUL = 3168;

# prints default device pathname for iSeries agent
function getDefaultDeviceName() {

        $ret = bp_get_device_list();

        if ($ret === false || $ret === NULL) {
                echo "error is: ".bp_error()."\n";
                return(false);
        } else {
                foreach ($ret as $line) {
                        $dev_id = bp_get_device_id($line);
                        if ($dev_id === false || $dev_id === NULL) {
                                echo "device " .$line. "not found. \n";
                                return(false);
                        } else {
                                $dev_info = bp_get_device_info($dev_id);
                                if ($dev_info["default"] == true) {
                                        $print_dev_name = $dev_info["dev_name"];
                                        print("" .$print_dev_name. "");
                                        return(true);
                                }
                        }
                }
        }
}

# gets a list of Clients for local DPU.
function getiSeriesClientList() {

	global $dbconn;
	$ret = bp_get_client_list();

//	echo "Made it to getiSeriesClientList().\n";

	if ($ret === false || $ret === NULL) {
		echo "error is: ".bp_error()."\n";
		return(false);
	} else {
		foreach ($ret as $line) {
			$client_name = ($line["client_name"]);
//			echo "client name is " .$client_name. ". \n";
			if ($client_name === false || $client_name === NULL) {
				echo "client " .$client_name. "not found. \n";
				return(false);
			} else {
				// Filter out grandclients (properties & 32)=32 CP_GRANCLIENT
				$query = pg_query($dbconn, "SELECT * FROM bp.nodes WHERE os = 33 AND (properties & 32)=0");
				if (!$query or pg_num_rows($query) == 0) {
	                		#return 1;
       				}
				while ($row = pg_fetch_row($query)) {
  					echo "$row[1]";
  					echo "\n";
				}

				$query = pg_query($dbconn, "SELECT system_id,gcname FROM bp.nodes WHERE os = 33 AND (properties & 32) = 32 ORDER BY system_id");
				if (!$query or pg_num_rows($query) == 0) {
					#return 1;
				}
				while ($row = pg_fetch_row($query)) {
					$system_id = $row[0];
					$gc_name = $row[1];

					$system_query = pg_query($dbconn, "SELECT name FROM bp.systems WHERE system_id = $system_id");
					if ( !$system_query or pg_num_rows($system_query) == 0 ) {
						continue;
					}
					$system = pg_fetch_row($system_query);

					echo "$system[0]->$gc_name";
  					echo "\n";
				}
				return(true);
			}
		}
	}
}

# prints default device pathname for iSeries agent
function getDefaultDevicePath() {

	$ret = bp_get_device_list();

	if ($ret === false || $ret === NULL) {
		echo "error is: ".bp_error()."\n";
		return(false);
	} else {
		foreach ($ret as $line) {
			$dev_id = bp_get_device_id($line);
			if ($dev_id === false || $dev_id === NULL) {
				echo "device " .$line. "not found. \n";
				return(false);
			} else {
				$dev_info = bp_get_device_info($dev_id);
				if ($dev_info["default"] == true) {
					$print_dev_name = $dev_info["dev_nr_name"];
					print("" .$print_dev_name. "");
					return(true);
				}
			}
		}
	}
}

# checks license to register the client. 
function checkLicenseToRegisterClient() {

	$license_info = bp_get_license_info();
	if ($license_info['class'] == 'FREE') {
		$ret = false;
	} else {
		$ret = true;
		if (($license_info['class'] == 'ENTRR') || ($license_info['class'] == 'NFR')) {
			$lic = bp_get_resource_license_limit();
			$use = bp_get_resource_license_usage();
			if (($lic['servers'] - $use['servers']) <= 0) {
				$ret = false;
			}
		}
	}
	return($ret);
}

# prints EPOCH date of the last master backup for this client
function checkClientExists($client) {

	global $dbconn;
	$client_id = bp_get_client_id($client);
	if ($client_id === false || $client_id === NULL) {
		echo "false\n";
		return(false);
	} else {
		echo "true\n";
		return(true);

	}
}

# prints EPOCH date of the last master backup for this client
function getLastMasterDate($client) {

	global $dbconn;
	$client_id = bp_get_client_id($client);
	if ($client_id === false || $client_id === NULL) {
		echo "client " .$client. "not found. \n";
	} else {
		$query = pg_query($dbconn, "SELECT last_master_start_time FROM bp.nodes WHERE node_name = '$client'");
		if (!$query or pg_num_rows($query) == 0) {
	                return 1;
       		}
        	$row = pg_fetch_row($query);
        	$client_lastMaster = $row[0];
		print("" .$client_lastMaster. "");
		return(true);

	}
}

# prints all backups started within the given date range
function getBackupDateRange($client, $epochMin, $epochMax) {

	global $dbconn;
	global $S_SUCCESSFUL;

	$client_id = 0;

	$grandclient = explode("->",$client);

	if (count($grandclient) > 1) {
		$query = pg_query($dbconn, "SELECT node_no FROM bp.nodes WHERE gcname = '$grandclient[1]' AND system_id = (SELECT system_id FROM bp.systems WHERE name = '$grandclient[0]')");
		if (!$query or pg_num_rows($query) == 0) {
			echo "failed to find $grandclient[0] -> $grandclient[1]";
		}

		$row = pg_fetch_row($query);
		$client_id = (int) $row[0];
	} else {
		$client_id = bp_get_client_id($client);
	}

	if ($client_id === false || $client_id === NULL) {
		echo "client " .$client. "not found. \n";
	} else {
		$backupTypes = array("master", "differential", "incremental", "selective");
		$result_format = array('type' => $backupTypes, 'client_id' => $client_id, 'start_time' => $epochMin, 'end_time' => $epochMax);
		$backupArray = bp_get_backup_status($result_format);
		if ($backupArray === false) {
			echo "backupArray is false\n";
			print("Resultant array is: \n");
			print_r($result_format);
			echo "\n";
	                return 1;
       		}
		#echo "After bp_get_backup_status \n";
		$numBackups = count($backupArray);
		foreach ($backupArray as $backupInfo) {
			$backupNum = $backupInfo['id'];
			$backupType = $backupInfo['type'];
			$backupStart = $backupInfo['start_time'];
			echo "$backupNum|$backupType|$backupStart \n";
		}
		return(true);
	}
}

# 5257
# set elapsed_time for backup in database backups table.
//function getBackupDateRange($client, $epochMin, $epochMax, $loop) {
function setBackupElapsedTime($elapsed, $backupNum) {

	global $dbconn;
	global $S_SUCCESSFUL;

	$query = pg_query($dbconn, "UPDATE bp.backups SET elapsed_time = $elapsed WHERE backup_no = $backupNum");
	return ($query ? 0 : 1);
}

# sets sync bit for iSeries client if user wants to vault iSeries backups
function setBackupMessagesFunc($backup, $messages) {
	global $dbconn;

	$query = pg_query($dbconn, "SELECT backup_no FROM bp.backup_msg WHERE backup_no = $backup");
	if (!$query or pg_num_rows($query) == 0) {
		$query = pg_query($dbconn, "INSERT INTO bp.backup_msg (backup_no, messages) VALUES ($backup, '$messages')");
       	} else {
		$query = pg_query($dbconn, "UPDATE bp.backup_msg SET messages = '$messages' WHERE backup_no = $backup");
	}
	return ($query ? 0 : 1);
}

# sets sync bit for iSeries client if user wants to vault iSeries backups
function setBackupStatusFunc($backup) {
	global $dbconn;

	$query = pg_query($dbconn, "UPDATE bp.backups SET status = 5216 WHERE backup_no = $backup");
	return ($query ? 0 : 1);
}

# sets sync bit for iSeries client if user wants to vault iSeries backups
function setClientSyncBit($client) {
	//echo "in setClientSyncBit, client is " .$client. "\n";
	global $dbconn;

	$client_id = bp_get_client_id($client);
	if ($client_id === false || $client_id === NULL) {
		echo "client " .$client. "not found. \n";
	} else {
		
		//echo "client_id is " .$client_id. "\n";
		// OR 1 for syncable into nodes.properties
		$query = pg_query($dbconn, "SELECT properties FROM bp.nodes WHERE node_no = $client_id");
		if (!$query or pg_num_rows($query) == 0) {
	                return 1;
       		}
        	$row = pg_fetch_row($query);
        	$client_properties = $row[0];

		$syncBit = $client_properties | 1;
		
		$query = pg_query($dbconn, "UPDATE bp.nodes SET properties = $syncBit WHERE node_no = $client_id");
		return ($query ? 0 : 1);
		//$new_client_array = bp_get_client_info($client_id);
		//print_r($new_client_array);
	}
}

# gets sync bit for iSeries client to see if backup sync bit shd be set
# 5229
function getClientSyncBit($client) {
	//echo "in setClientSyncBit, client is " .$client. "\n";
	global $dbconn;

	$client_id = bp_get_client_id($client);
	if ($client_id === false || $client_id === NULL) {
		echo "client " .$client. " not found. \n";
		return(false);
	} else {
		$clientInfoArray = bp_get_client_info($client_id);
                if ($clientInfoArray === false || $clientInfoArray === NULL) {
                                echo "client info for " .$client. "not found. \n";
                                return(false);
		} else {
			if ($clientInfoArray["is_synchable"] === true) {
				return(true);
			} else {
				return(false);
                        }
       		}
	}
}

# Set the backup to replicate (bptool -s option has been discontinued)
function setBackupSyncNeeded($bkup_no) {
	global $dbconn;

	$query = pg_query($dbconn, "SELECT backup_no FROM bp.backup_msg WHERE backup_no = $bkup_no");
	if (!$query or pg_num_rows($query) == 0) {
		echo "backup $bkup_no not found.\n";
		return(false);
	}
	// ST_SYNC_NEEDED is 1
	$query = pg_query($dbconn, "UPDATE bp.backups SET sync_status = 1 WHERE backup_no = $bkup_no");
	return ($query ? 0 : 1);
}

function iSeries_db_connect() {
        $conn = pg_connect("port=5432 dbname=bpdb user=postgres connect_timeout=30");
        return $conn;
}

// main program starts here

$getDevice = false;
$getClientList = false;
$checkLicense = false;
$getDeviceName = false;
$syncClient = false;
$getMasterDate = false;
$getClientExists = false;
$setBackupStatus = false;
$setBackupMessages = false;
$getDateRange = false;
$getSyncBit = false;
$setSyncNeeded = false;
$setElapsedTime = false;

$dbconn = iSeries_db_connect();
if ($dbconn === FALSE) {
       die(1);
}


if($argc < 2) {
        echo "Usage: $argv[0] [-d | -n | -e <client_name> | -m <client_name> | -j <backup_job_number> | -s <client_name> | -g <client_name>] | -t <elapsed_secs> <backup_job_num>\n";
        echo "       -d to request default d2d device path\n";
        echo "       -l to request list of registered iSeries clients\n";
        echo "       -L to check license to register new client\n";
        echo "       -n to request default d2d device name\n";
        echo "       -e <client_name> to see if a client already exists in the database\n";
        echo "       -m <client_name> to request the EPOCH date of the last master for this client\n";
        echo "       -c <client_name> to turn on sync bit for client_name\n";
        echo "       -j <backup_job_number> to indicate in database that backup job failed\n";
        echo "       -e <backup_job_messages> set backup_msg for backup job on failure\n";
        echo "       -r <client_name> <EPOCH_min> <EPOCH_max> to list a backups in date range\n";
        echo "       -g <client_name> to determine if sync bit is set for client\n";
        echo "       -s <backup_no> set sync needed on the backup\n";
        echo "       -t <elapsed seconds> <backup_job_number> to set elapsed backup time in seconds for backup\n";
        die;
}
else {
        for ($i = 1; $i < $argc; $i++)  {
//              echo "$i: $argv[$i]\n";
                switch ($argv[$i]) {
                        case '-d':
                                $getDevice = true;
                                break;
                        case '-n':
                                $getDeviceName = true;
                                break;
                        case '-l':
                                $getClientList = true;
                                break;
                        case '-L':
                                $checkLicense = true;
                                break;
                        case '-c':
				$syncClient = true;
                                $clientName = $argv[++$i];
                                break;
                        case '-e':
				$getClientExists = true;
                                $clientName = $argv[++$i];
                                break;
                        case '-m':
				$getMasterDate = true;
                                $clientName = $argv[++$i];
                                break;
                        case '-j':
				$setBackupStatus = true;
                                $backupNumber = $argv[++$i];
                                break;
                        case '-b':
				$setBackupMessages = true;
                                $backupMessages = $argv[++$i];
                                break;
			case '-r':
				$getDateRange = true;
                                $clientName = $argv[++$i];
                                $epochMin = $argv[++$i];
                                $epochMax = $argv[++$i];
                                //$loop = $argv[++$i];
                                break;
                        case '-g':
                                $getSyncBit = true;
                                $clientName = $argv[++$i];
                                break;
                        case '-s':
                                $setSyncNeeded = true;
                                $backupNumber = (int)$argv[++$i];
                                break;
			case '-t':
				$setElapsedTime = true;
                                $elapsedSecs = $argv[++$i];
                                $backupJobNum = $argv[++$i];
                                break;
                }
        }
}

$testname = 'Test bp_get_device_list';
bp_bypass_cookie(3);

if ($getDevice === true) {
	if (getDefaultDevicePath() === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($getClientList === true) {
	if (getiSeriesClientList() === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($checkLicense === true) {
	if (checkLicenseToRegisterClient() === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($getDeviceName === true) {
	if (getDefaultDeviceName() === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($syncClient === true) {
	if (setClientSyncBit($clientName) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($getClientExists === true) {
	if (checkClientExists($clientName) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($getMasterDate === true) {
	if (getLastMasterDate($clientName) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($setBackupStatus === true) {
	if (setBackupStatusFunc($backupNumber) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($setBackupStatus === true && $setBackupMessages === true) {
	if (setBackupMessagesFunc($backupNumber, $backupMessages) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

if ($getDateRange === true) {
	//if (getBackupDateRange($clientName, $epochMin, $epochMax, $loop) === false) {
	$epochIntMin = (int) $epochMin;
	$epochIntMax = (int) $epochMax;
	if (getBackupDateRange($clientName, $epochIntMin, $epochIntMax) === false) {
		bp_destroy_cookie();
		die(1);
	}
}

// 5257
if ($setElapsedTime === true) {
	$elapsedIntSecs = (int) $elapsedSecs;
	if (setBackupElapsedTime($elapsedIntSecs, $backupJobNum) === false) {
		bp_destroy_cookie();
		die(1);
	}
}
if ($getSyncBit === true) {
	if (getClientSyncBit($clientName) === false) {
		bp_destroy_cookie();
		die(1);
	}
}
if ($setSyncNeeded === true) {
	if (setBackupSyncNeeded($backupNumber) === false) {
		bp_destroy_cookie();
		die(1);
	}
}


bp_destroy_cookie();
pg_close($dbconn);


?>

