#!/bin/bash
# 2290	MBE	Capitalize Exchange.


checkYorN ()
{
	case $1 in
		n* | N*) return 0;;
		*) return 1;;
	esac
}

. /etc/default/bp.ini 2>/dev/null

clear
if ! [ -f $1 ]
then
	exit 0
fi
echo "********************************"
echo "Size KB / Database File Name"
ls -sk $1
echo "********************************"
echo -n "Continue with transfer of database file to DPV? (Y/N) "
echo -n "Default is (Y)es:"
read
checkYorN $REPLY
if [ $? -eq 0  ]
then
        clear
        echo "You have chosen to delay transfer of the SQL file to DPV."
        echo "Currently, all Exchange vault transfers have been disabled."
        echo ""
        echo "When the transfer is complete, you will need to re-enable"
        echo "this feature on the DPU by running: " 
        echo ""
        echo $BPDIR/bin/unitrends_enable_vault_transfer.sh
        echo ""
        echo "You may transfer the file from this DPU and reset this config option"
        echo "by running:"
        echo ""
        echo $BPDIR/bin/transfer_sql_dpv.sh $1
        echo ""
# 2254
#        echo "Press [ENTER] to continue..."
#        read
	exit 0
fi

$BPDIR/bin/dpv_bp_sql_run.sh $1
# 2443
if [ $? -ne 0 ]
then
	echo "Could not transfer data to DPV.  Please ensure that a connection"
	echo "to the DPV can be established and run this script again."
	echo ""
	exit 1
fi

$BPDIR/bin/unitrends_enable_vault_transfer.sh
#2443
if [ $? -ne 0 ]
then
	echo "Error enabling vault transfer in the database."
	echo ""
	exit 2
fi


mv $1 $1.old
clear
echo "You have successfully setup the database on the DPV "
echo "for Exchange vaulting. "
echo ""
# 2254
#echo "Press [ENTER] to continue..."
#read
