#!/bin/sh -u

# Scans for archive media

. /etc/default/bp.ini 2> /dev/null
. ${BPDIR}/bin/uarchive-scripts/constants.incl

. ${BPDIR}/bin/uarchive-scripts/capabilities.incl
. ${BPDIR}/bin/uarchive-scripts/media_3ware.incl
. ${BPDIR}/bin/uarchive-scripts/media_contents.incl
. ${BPDIR}/bin/uarchive-scripts/media_removable.incl
. ${BPDIR}/bin/uarchive-scripts/mount.incl

################################################################################
# Finds and prints device list
#
# Fields (pipe-delimited, important fields shown in <angle brackets>):
#    <devname>|<size>|<type>|vendor|model|<label>|<numclients>|<client,list>
#    |devlink|<originatingasset>|<devnode>
GetArchiveDeviceList()
{
	TwMediaFound="n"
	RemovableMediaFound="n"
	if TwArchivingSupported; then
		Find3WareMedia || return 1
	fi
	if RemovableArchivingSupported; then
		FindRemovableMedia || return 1
	fi

	SelectionArray=()
	if [ "$TwMediaFound" = "y" ]; then
		SelectionArray[${#SelectionArray[@]}]=${TwArray[0]}
	fi
	for i in $(seq 0 $((${#RemovableArray[@]} - 1))); do
		SelectionArray[${#SelectionArray[@]}]=${RemovableArray[$i]}
	done

	# Print array
	for i in $(seq 0 $((${#SelectionArray[@]} - 1))); do
		if [ $i -gt 0 ]; then
			echo ""  # start a new line
		fi
		echo "${SelectionArray[$i]}" | tr '\n' ' '
	done

	return 0
}


# Store devices to not mount
no_mount=("$@")

# Find and print the device list
GetArchiveDeviceList
exit $?



# End marker to help vim identify syntax of .incl files
# vim: syn=sh
