package EventLogging;
require Exporter;

our @ISA = ("Exporter");
our @EXPORT = qw(logevent geteventgroup);

sub logevent ($$$$$$$$);
sub geteventgroup ($$$);


sub geteventgroup ($$$)
{
	
	# Set up an event group for logging.
	my ($bpdbConn, $bpevent, $description) = @_;
	my $eventGroupQuery = 'SELECT bp.createeventgroup(\'' . $bpevent . '\',';
	$eventGroupQuery .= '\'' . $description . '\')';
	my $eventGrp_result = $bpdbConn->exec($eventGroupQuery);
	return  ($eventGrp_result->resultStatus, $eventGrp_result->getvalue(0,0));
}

sub logevent ($$$$$$$$)
{
# This routine calls the addeventlog stored procedure:
# addeventlog(pglobal "bool",plevel "int4", pevtype "int4", psource "varchar",
#             pmsg "varchar", phost "varchar", pEventGroupId int4)
#
# pglobal:       if true => it goes into bp.eventlog 
# plevel:        0=FATAL 1=ERROR 2=WARNING 3=INFO 4=DEBUG 
# pevtype:       an eventtypeid from the eventtype table (preloaded)
# psource:       process or application 
# pmsg:          message that explains the event
# phost:         hostname where event originated
# pEventGroupId: current eventgroupid obtained from createeventgroup
#
	my $bpdbConn = shift;
	my $n = 1;
	my $lastindex = @_ ;
	my $addEventQuery = 'SELECT bp.addeventlog(';
	foreach (@_) {
		if ($n == 2 || $n == 3 || $n == 7) {
			$addEventQuery .= $_ ;
		}
		else {
			if ($n == 5) {
				$addEventQuery .= '$$' . $_ . '$$';
			}
			else {
			$addEventQuery .= '\'' . $_ . '\'';
			}
		}
		if ($n != $lastindex) {
			$addEventQuery .= ',';
		}
		$n++;
	}
	$addEventQuery .= ')';
	my $addEvent_result = $bpdbConn->exec($addEventQuery);
	return $addEvent_result->resultStatus;
	# Don't check status since we just continue if it failed.
}
