:
[ -n "$BASH_VERSION" ] && enable -n echo # Forces System V echo (/bin/echo) 
##!/bin/sh
##
## BP utility script to scratch/retire the tape in the drive
##
## Usage: scratchT.sh <device_nickname>
##

if [ $# -ne 1 ]; then
	echo "Usage: scratchT.sh <device_nickname>"
	exit 1
fi

TMP=/tmp/scratchT
TAPE=$1
if [ -z "$BPDIR" ]
then
	BPDIR=`sed -n '/BPDIR=/s/.*=//p' /etc/default/bp.ini `
	: ${BPDIR:=/usr/bp}
fi
INI="$BPDIR/bpinit/master.ini"
EXPIRE_DAYS=`${BPDIR}/bin/bputil -g $TAPE DefExpirationDays 5 $INI 2>/dev/null`
## If not set yet, lets get the default value
if [ -z "$EXPIRE_DAYS" ]
then
	EXPIRE_DAYS=`${BPDIR}/bin/bputil -g "Tape Commands" DefExpirationDays 5 $INI 2>/dev/null`
fi
## If still not set, use 5
: ${EXPIRE_DAYS:=5}
## Set up the option string 
EXPIRE_DAYS="-e $EXPIRE_DAYS"

${BPDIR}/bin/inittape -s -d ${TAPE:=sctape} -y $EXPIRE_DAYS > $TMP 2>&1
if [ $? -eq 0 ]; then
	echo "Tape has been successfully scratched"
	echo "-----------------------------------"
	grep TL_TAPE_NUMBER $TMP
	grep TL_CREATE_DATE_ENGLISH $TMP
	grep TL_NODE $TMP
	grep TL_SITE_LOCATION $TMP
	grep TL_COMMENT $TMP
	grep TL_EXPDATE_ENGLISH $TMP
	exit 0
else
	cat $TMP
	exit 1
fi
rm -f $TMP

