<?php
// archive functions
require 'arfunctions.php';

// defines BP, xml, action, cookie
require '../header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {				
		
	case "list":	// List archive sets
			$result_format = array();
			if (isset($_GET['start'])) {
				$result_format['job_start_time'] = (int)$_GET['start'];
			}
			if (isset($_GET['end'])) {
				$result_format['job_end_time'] = (int)$_GET['end'];
			}
			if (isset($_GET['target'])) {
				$result_format['target'] = $_GET['target'];
			}
			$result = $BP->get_archive_sets($result_format, $dpuID);
			if ($result !== false) {
				$xml->push('root');
				foreach ($result as $set) {
					$attributes = array();
					$attributes['ID'] = $set['archive_set_id'];
					$xml->push('Set', $attributes);
					$xml->element('Description', $set['description']);
					$date = date('m/d/Y   h:i:sA', $set['timestamp']);
					$xml->element("Date", $date);
					$xml->element("Status", $set['status']);
					$xml->element("Available", $set['available'] == true ? '1' : '0');
					$xml->pop(); // Set
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;

	case "info":	// Get archive set info.
			$result_format = array();
			if (isset($_GET['id'])) {
				$setID = (int)$_GET['id'];
				$setInfo = $BP->get_archive_set_info($setID, $dpuID);
				if ($setInfo !== false) {
					$xml->push('root');
					$attributes = array();
					$attributes['ID'] = $setID;
					$xml->push('Set', $attributes);
					$xml->element('Description', $setInfo['description']);
					$date = date('m/d/Y   h:i:sA', $setInfo['timestamp']);
					$xml->element("Date", $date);
					$xml->element("Status", $setInfo['status']);
					$xml->element("Available", $setInfo['available'] == true ? '1' : '0');
					if (isset($setInfo['media_serials'])) {
						$xml->element("Serials", $setInfo['media_serials']);
					}
					if (isset($setInfo['media_label'])) {
						$xml->element("Label", $setInfo['media_label']);
					}
					// elapsed time for this archive set.
					if (isset($setInfo['elapsed_secs'])) {
						$xml->element('ElapsedTime', $setInfo['elapsed_secs']);
					}
					// is this archive set in the database?
					if (isset($setInfo['is_imported'])) {
						$xml->element('Imported', $setInfo['is_imported'] ? '1' : '0');
					}
					
					// barcodes for tapes
					if (isset($setInfo['barcodes'])) {
						$serials = isset($setInfo['media_serials']) ? $setInfo['media_serials'] : "";
						tapeInfoToXML($xml, $setInfo['barcodes'], $serials);
					}
					$xml->element("AssetTag", $setInfo['originating_asset']);
					// list the profile XML....
					if (isset($setInfo['profile'])) {
						profileToXML($xml, $setInfo['profile']);
					}
					$xml->pop(); // Set
					$xml->pop(); // root
				} else {
					$BP->buildResult($xml, false);
				}
			} else {
				$BP->buildResult($xml, false, "Must specify archive set ID to display the set information.");
			}
			echo($xml->getXml());
			break;
			
	case "purge":	// Purge archive set by set ID
			if (isset($_GET['id'])) {
				$setID = (int)$_GET['id'];
				$BP->buildResult($xml, $BP->purge_archive_catalog($setID, $dpuID));
			} else {
				$BP->buildResult($xml, false, 'ID of archive set to be purged must be specified.');
			}
			echo($xml->getXml());
			break;
			
	case "clients":  //get archive clients
	global $Log;
		if($grandClientView) {
			$archiveClientsArray = $BP->get_archive_grandclients($dpuID);
			if($archiveClientsArray !== false) {
				$xml->push("root");
				foreach($archiveClientsArray as $archiveClients){
					$xml->push("Client");
					$xml->element("ID", $archiveClients['client_id']);
					$xml->element("Name", $archiveClients['gcname']);
					$xml->pop(); //client
				}
					$xml->pop("root");	
			} else {
				$BP->buildResult($xml, false);
			}
		} else {
		
		
		$archiveClientsArray = $BP->get_archive_client($dpuID);

		if($archiveClientsArray !== false){
			$xml->push("root");
			foreach($archiveClientsArray as $archiveClients){
				$xml->push("Client");
				$xml->element("ID", $archiveClients['id']);
				$xml->element("Name", $archiveClients['name']);
				$xml->pop(); //client
			}
			$xml->pop("root");			
		
		} else {
			$BP->buildResult($xml, false);
		}
		}
		echo($xml->getXml());
		break;
}

function tapeInfoToXML ($xml, $barcodes, $serials) {
	$serials = explode(",", $serials);
	
	$xml->push('Tapes');
	
	// match up barcodes with serials
	foreach ($serials as $key=>$serial) {
		// the serials array starts at 0, but volumes start at 1
		$xml->push('Tape', array('Volume'=>$key+1));
		$xml->element('Serial', $serial);
		if (isset($barcodes[$key+1])) {
			$xml->element('Barcode', $barcodes[$key+1]);
		}
		$xml->pop();
	}
	
	$xml->pop();
}

$BP->destroyCookie();
?>