<?php
// archive functions
require 'arfunctions.php';

// defines BP, xml, action, cookie
require '../header.php';

// general library functions
require $rootdir . 'bpl/library.php';
$lib = new Library();

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {				
	
	case "list":	// List archive status
			$result_format = array();
			if (isset($_GET['set'])) {
				$result_format['archive_set_id'] = (int)$_GET['set'];
			}
			if (isset($_GET['cid'])) {
				$result_format['client_id'] = (int)$_GET['cid'];
			}
			if (isset($_GET['btype'])) {
				$result_format['type'] = $lib->getStringArray($_GET['btype']);
			}
			if (isset($_GET['start'])) {
				$result_format['job_start_time'] = (int)$_GET['start'];
			}
			if (isset($_GET['end'])) {
				$result_format['job_end_time'] = (int)$_GET['end'];
			}
			if (isset($_GET['bkstart'])) {
				$result_format['backup_start_time'] = (int)$_GET['bkstart'];
			}
			if (isset($_GET['bkend'])) {
				$result_format['backup_end_time'] = (int)$_GET['bkend'];
			}
			if (isset($_GET['ids'])) {
				$result_format['archive_ids'] = $lib->getIDs($_GET['ids']);
			}
			if (isset($_GET['target'])) {
				$result_format['target'] = $_GET['target'];
			}

			$resultArray = $BP->get_archive_status($result_format, $sysID);
			if ($resultArray !== false) {
				$xml->push('root');
				foreach ($resultArray as $result) {
					
					// Archive-Specific Properties
					$attributes = array();
					$attributes['Identification'] = $result['archive_id'];
					$attributes['Set'] = $result['archive_set_id'];
					$attributes['Type'] = getBackupTypeString($result['type'], true);
					$xml->push('Archive', $attributes);
	
					if (isset($result['archive_time'])) {
						$date = date('m/d/Y   h:i:sA', $result['archive_time']);
						$xml->element('Date', $date);
						$xml->element('Time', $result['archive_time']);
					}
					// elapsed time for this archive.
					if (isset($result['elapsed_secs'])) {
						$xml->element('ElapsedTime', $result['elapsed_secs']);
					}
					// is this archive in the database?
					if (isset($result['is_imported'])) {
						$xml->element('Imported', $result['is_imported'] ? '1' : '0');
					}	
					// For archives, unlike backups, success is a boolean (for backup, it is a tri-state integer).
					// It should always be there (no in-progress archives as statuses are updated once complete).
					if (isset($result['success'])) {
						$xml->element('Result', $result['success'] == true ? "Success" : "Failure");
						$xml->element('Complete', 1);
					}
					
					// Archived Backup Source Properties
					if (isset($result['client_id'])) {
						$xml->element('ClientID', $result['client_id']);
					}
					if (isset($result['instance_id'])) {
						$xml->element('InstanceID', $result['instance_id']);
					}
					$xml->element('Client', $result['client_name']);
					if (isset($result['os_type_id'])) {
						$xml->element('OSID', $result['os_type_id']);
					}
					if (isset($result['os_type'])) {
						$xml->element('OS', $result['os_type']);
					}
					if (isset($result['app_id'])) {
						$xml->element('AppID', $result['app_id']);
					}
					if (isset($result['deduped'])) {
						$xml->element('Deduplicated', $result['deduped']);
					}
					
					if (isset($result['fastseed'])) {
						$xml->element('FastSeed', $result['fastseed']);
					}
					if (isset($result['app_name'])) {
						$xml->emptyelement('Application', array('Name' => $result['app_name']));
					}
					$xml->element('InstanceDescription', $result['instance_description']);
					
					$newDesc = $result['instance_description'];
					$pieces = explode('"', $newDesc);
					
					if(count($pieces) > 1) {
						if($result['app_name'] == "VMware"){
							$xml->element('shortDescription', $pieces[3]);
						} else {
							$xml->element('shortDescription', $pieces[1]);
						}
					}
					// Archived Backup Properties
					if (isset($result['orig_description'])) {
						$xml->element('Description', $result['orig_description']);
					}
					if (isset($result['orig_backup_id'])) {
						$xml->element('BID', $result['orig_backup_id']);
					}
					//$xml->element("Type", getBackupTypeString($result['type']));
					$date = date('m/d/Y   h:i:sA', $result['backup_time']);
					$xml->element("BackupDate", $date);
					$xml->element("BackupEpoch", $result['backup_time']);
					$xml->element("Size", $result['size']);
					$xml->element("Files", $result['files']);
					$xml->element("Compressed", $result['compressed'] == true ? '1' : '0');
					$xml->element("Encrypted", $result['encrypted'] == true ? '1' : '0');

					// If VMware Template
					if (isset($result['vmware_template'])) {
						$xml->element('Template', ( $result['vmware_template'] == 1 ) ? 1 : 0 );
					}
					
					// VSS Support
					if (isset($result['support_vss_diff'])) {
						$xml->element('VSSDiff', ( $result['support_vss_diff'] == 1 ) ? 1 : 0 );
					}
					
					if (isset($result['error_string'])) {
						$xml->element("ErrorString", $result['error_string']);
					}
					$xml->pop(); // Archive
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			

}

$BP->destroyCookie();
?>