<?php

function displaySections($xml, $BP, $sectionsList)
{
	foreach ($sectionsList as $sectionName) {
		displaySection($xml, $BP, $sectionName);
	}
}

function displaySection($xml, $BP, $sectionName)
{
	global $dpuID;
	$sectionValues = $BP->get_ini_section($sectionName, $dpuID);
	if ($sectionValues === false) {
		$xml->push("Section", array("Name" => $sectionName, "Warning" => "1"));
		$xml->emptyelement("Field", array("Name" => "Warning: Could not load section.",
										  "Description" => "N/A",
										  "Value" => "N/A"));
		global $Log;
		$errorString = "error getting configuration section:" . $sectionName . ".";
		$Log->writeError($errorString, true);
	} else {
		$xml->push("Section", array("Name" => $sectionName));
		foreach ($sectionValues as $setting) {
			$name = $setting['field'];
			$description = array_key_exists('description', $setting) ? $setting['description'] : "";
			$value = $setting['value'];
			$xml->emptyelement("Field", array("Name" => $name, "Description" => $description, "Value" => $value));
		}
	}
	$xml->pop(); // Section
}

function displayField($xml, $BP, $sectionName, $field)
{
	global $dpuID;
	$xml->push("Section", array("Name" => $sectionName));
	$value = $BP->get_ini_value($sectionName, $field, $dpuID);
	$xml->emptyelement("Field", array("Name" => $field, "Value" => $value));
	$xml->pop(); // Section
}

function buildFVArray($fvString)
{
	$fvArray = array();
	
	$stringSeparator = 'zxywz';
	// fv string will be in the form <field>:<value>,<field>:<value>, ...
	$fvString = trim($fvString, ",");

	$fvPairs = explode(",", $fvString);
	foreach ($fvPairs as $fvPair) {
		$pieces = explode($stringSeparator, $fvPair);		
		if ($pieces[0] != "") {
			$field= $pieces[0];
			$value = $pieces[1];			
			$fvArray[$field] = $value;
		}	
	}	
	return $fvArray;
}

?>