<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for URL parsing.
require('urloptions.php');

// general library functions
require 'library.php';
$lib = new Library();

$backupIDs = isset($_GET['bids']) ? $_GET['bids'] : NULL;

//if $set, use value passed in, else default to clear certified status
$set = isset($_GET['set']) ? $_GET['set'] : -1;


switch ($action) {				 
	case "set":	//used to set the backup's certified status:			
				//0 = no certification
				//1 = error during certification
				//2 = not certified (the VM is part of an RDR job but not powered on during certification)
				//3 = successfully certified
				//4 = certified, but with a warning
				//-1 = clear the certification status

		if ($backupIDs !== NULL) {
			$backupsArray = $lib->getIDs($_GET['bids']);
			
			$result = $BP->set_certification_status($set, $backupsArray);
			if ($result !== false) {
				$BP->buildResult($xml, true);
			} else {
				$BP->buildResult($xml, false);
			}
		} else {
			$BP->buildResult($xml, "Backup IDs must be specified using 'bids' option.");
		}
		echo($xml->getXml());
		break;
	
	case "get":
		if ($backupIDs !== NULL) {
			$backupsArray = $lib->getIDs($_GET['bids']);
			
			$result_format = array('backup_ids' => $backupsArray);
			$backupArray = $BP->get_backup_status($result_format);
			
			if ( $backupArray !== false ) {
				$xml->push("root");
				foreach ($backupArray as $backup) {
					if (strstr($backup['type'], 'securesync') == false) {
						$xml->push('Backup');
						$xml->element('Backup_ID', $backup['id']);
						if (isset($backup['certified'])) {
							$xml->element('Certified', $backup['certified']);
						}
						$xml->pop(); //Backup
					}
				}
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
}

$BP->destroyCookie();
?>
