<?php
//
// Define backup certification field possible values.
// Possible values as of 3/7/2014
// 0 = no certification
// 1 = error during certification
// 2 = not certified (the VM is part of an RDR job but not powered on during certification)
// 3 = successfully certified
// 4 = certified, but with a warning
// -1 = clear the certification status
				
define("STATUS_CERTIFY_API_KEY", "certified");
define("STATUS_CERTIFY_XML_NODE", "Certified");

define("STATUS_CERTIFY_NONE", 0);
define("STATUS_CERTIFY_ERROR", 1);
define("STATUS_CERTIFY_NOTRUN", 2);
define("STATUS_CERTIFY_SUCCESS", 3);
define("STATUS_CERTIFY_WARNING", 4);

define("STATUS_CERTIFY_NONE_STRING", "Certification none");
define("STATUS_CERTIFY_ERROR_STRING", "Certification completed with errors");
define("STATUS_CERTIFY_NOTRUN_STRING", "Certification not performed");
define("STATUS_CERTIFY_SUCCESS_STRING", "Certification successful");
define("STATUS_CERTIFY_WARNING_STRING", "Certification successful with warnings");

function getStringForCertifyStatus($certifyStatus) {
	$ret = "";
	switch ($certifyStatus) {
		case STATUS_CERTIFY_NONE:	 $ret = STATUS_CERTIFY_NONE_STRING; break;
		case STATUS_CERTIFY_ERROR:	 $ret = STATUS_CERTIFY_ERROR_STRING; break;
		case STATUS_CERTIFY_NOTRUN:	 $ret = STATUS_CERTIFY_NOTRUN_STRING; break;
		case STATUS_CERTIFY_SUCCESS: $ret = STATUS_CERTIFY_SUCCESS_STRING; break;
		case STATUS_CERTIFY_WARNING: $ret = STATUS_CERTIFY_WARNING_STRING; break;
		default:					 $ret = ""; break;
	}
	return $ret;
}

function getCertifyStatusAttributesArray($certifyStatus) {
	$certifyAttributes = array();
	
	$certifyAttributes["Status"] = $certifyStatus;
	$certifyAttributes["Message"] = getStringForCertifyStatus($certifyStatus);
	
	return $certifyAttributes;
}

?>