<?php
// defines BP, xml, action, cookie
require 'header.php';

switch ($action) {

	case "slist":
	case "list":
			$bValid = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$dnsList = ($action == 'list') ? $BP->get_dns_list($dpuID) : $BP->get_dns_search_list($dpuID);
			if ($dnsList === false) {
				$bValid = false;
			} else {
				$xml->push("root");
				foreach ($dnsList as $dnsIP) {
					$xml->emptyelement("DNS", array("IP" => $dnsIP));
				}
				$xml->pop(); //root
			}
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "lists":
			$bValid = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$dnsList = $BP->get_dns_list($dpuID);
			if ($dnsList === false) {
				$bValid = false;
			} else {
				$searchList = $BP->get_dns_search_list($dpuID);
				if ($searchList === false) {
					$bValid = false;
				} else {
					$xml->push("root");
					foreach ($dnsList as $dnsIP) {
						$xml->emptyelement("DNS", array("IP" => $dnsIP));
					}
					foreach ($searchList as $dnsDomain) {
						$xml->emptyelement("Search", array("Name" => $dnsDomain));
					}
					$xml->pop(); //root
				}
			}
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "update":
			// update dns list
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$dnsList = false;
			$searchList = false;
			if (isset($_GET['dns'])) {
				$dnsString = $_GET['dns'];
				$dnsList = $dnsString != "" ? buildDNSList($dnsString) : array();
			}
			if (isset($_GET['search'])) {
				$dnsString = $_GET['search'];
				$searchList = $dnsString != "" ? buildDNSList($dnsString) : array();
			}
			if (is_array($dnsList)) {
				$result = $BP->save_dns_list($dnsList, $dpuID);
				if ($result === false) {
					$BP->buildResult($xml, false);
				} else {
					if (is_array($searchList)) {
						$result = $BP->save_dns_search_list($searchList, $dpuID);
						$BP->buildResult($xml, $result);
					}
				}
			}
			echo($xml->getXml());
			break;
}

//
// This function creates an array of entries from a comma-separated list.
//
function buildDNSList($dnsString)
{
	$dnsList = array();	
	// dns string will be in the form <dns ip#>,<dns ip#>, ...
	$dnsString = trim($dnsString, ",");
	$dnsValues = explode(",", $dnsString);
	$i = 0;
	foreach ($dnsValues as $dnsValue) {
		$dnsList[$i++] = $dnsValue;	
	}	
	return $dnsList;
}

$BP->destroyCookie();
?>
