<?php
// defines BP, xml, action, cookie
require '../header.php';
require 'dpurestorefunctions.php';

global $Log;

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
	case "list":
		$dpuuserlist = $BP->get_vaulted_dpus();
		if ($dpuuserlist !== false) {		
			$xml->push("root");
			foreach ($dpuuserlist as $dpu) {
				$dpuName = $BP->get_dpu_name($dpu);
				if($dpuName !== false){
					$dpuIp = $BP->get_host_info($dpuName);
					if($dpuIp !== false){	
						$xml->push("DPU");
						$xml->element("Name", $dpuName);
						$xml->element("User", $dpu);  
						$xml->element("IP", $dpuIp['ip']);
						$xml->pop(); //dpu
					}
				}
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
	
	case "check":
		$Log->writeVariable("in check for dr running");
		
		$syncUser = $_GET['user'];
		$ip = $_GET['ip'];
	
		$isDRRunning = $BP->dr_in_progress($syncUser, $ip);
		//  Sonja, the check can't return false, or build result will see an error.  Need to craft it like this.
		// isDRRunning needs to return true if running, false if not, and -1 on error (an API signature change).
		if ($isDRRunning !== false) {
			$xml->push('root');
			$xml->element('Running', $isDRRunning);
			$xml->pop(); // root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;		
	
	case "save_preference":
		$user = $_GET['user'];
		$name = $_GET['name'];
		$bSave = $_GET['bsave']  == '1'? true : false;
		
		$result = $BP->save_auto_dr_preference($bSave, $user, $name);
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;	
	
	case "save_profile":

		$user = $_GET['user'];
		$ip = $_GET['ip'];
		$name = $_GET['name'];
		
		$strDate = $_GET['start_date'];
		$strTime = $_GET['start_time'];
		
		$Log->writeVariable("time sent pre");
		$Log->writeVariable($strTime);
		
		$start_time = $strDate . $strTime;
		
		$frequency = $_GET['frequency'];
		
		$bSave = $_GET['bsave']  == '1'? true : false;
		$bReplace = $_GET['breplacestorage']  == '1'? true : false;
		$bCheckEncryption = $_GET['bcheckencryption']  == '1'? true : false;
		
		$clientDevices = xmlToClients($_REQUEST['clients']);
		
		$profileArray = array("sync_user" => $user,
							   "target_ip" => $ip,
							   "dpu_name" => $name,
							   "start_time" => $start_time,
							   "frequency" => $frequency,
							   "next_run" => $start_time,
							   "last_run" => "",
							   "replace_storage" => $bReplace,
							   "auto_dr" => $bSave,
							   "check_encryption" => $bCheckEncryption,
							   "clients_devices" => $clientDevices);

		$result = $BP->save_auto_dr_profile($profileArray);
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;	
		
	case "remove_profile":
		$user = $_GET['user'];
		$ip = $_GET['ip'];
		
		$result = $BP->remove_auto_dr_profile($user, $ip);	
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;	
	
	case "load_profile":
		$user = $_GET['user'];
		$ip = $_GET['ip'];
		
		$profile = $BP->load_auto_dr_profile($user, $ip);	
		
		if ($profile !== false){
			$xml->push('root');
			$bPresent = isset($profile['profile_present']) ? $profile['profile_present'] : false;
			$xml->element('Present', $bPresent ? '1' : '0');
			if ($bPresent) {
				// build XML or profile array.
				if (isset($profile['profile_info'])) {
					buildDRProfile($xml, $profile['profile_info']);
				} else {
					$BP->buildResult($xml, false, 'no profile contents found');
				}
			}
			$xml->pop(); // root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
	
	case "clients":	
	
		$user = $_GET['user'];
		$name = $_GET['name'];
		$dpuclients = $BP->get_dpu_clients($user, $name);

		if($dpuclients !== false){            
			$xml->push('root');
			foreach ($dpuclients as $client) {
				$xml->push('Client');
				$xml->element('Name', $client);	
				$xml->pop(); // client
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
}

//
// builds XML of DR profile.
//
function buildDRProfile($xml, $profile) {
	$xml->push('Profile');
	$xml->element('SyncUser', $profile['sync_user']);
	$xml->element('StartTime', $profile['start_time']);
	$xml->element('DPUName', $profile['dpu_name']);
	$xml->element('TargetIP', $profile['target_ip']);
	$xml->element('Frequency', $profile['frequency']);
	if (isset($profile['last_run'])) {
		$xml->element('LastRun', $profile['last_run']);
	}
	$xml->element('NextRun', $profile['next_run']);
	$xml->element('Replace', $profile['replace_storage'] ? '1' : '0');
	$xml->element('Auto', $profile['auto_dr'] ? '1' : '0');
		$xml->element('CheckEncryption', $profile['check_encryption'] ? '1' : '0');
	if (isset($profile['clients_devices'])) {
		//$xml->push('root');
		$clientDevices = $profile['clients_devices'];
		foreach ($clientDevices as $clientDevice) {
			$xml->push('ClientDevice');
			$xml->element('Client', $clientDevice['client_name']);
	
			if(array_key_exists('device_name', $clientDevice)) {			
				$xml->element('Device', $clientDevice['device_name']);
				$xml->element('Path', $clientDevice['device_path']);
			}
			$xml->pop(); // ClientDevice
			//$xml->pop(); //root
		}
	}
	$xml->pop(); // Profile
}

$BP->destroyCookie();
?>
