<?php
// defines BP, xml, action, cookie
require 'header.php';

// include status summary functions.
require 'status/summary.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$days = isset($_GET['days']) ? (int)$_GET['days'] : 7;

//
//  Wrapper to get summary backup or vaulting status.
//
//  user passes in on URL:
//
//  # days (optional), defaults to 7
//  end time epoch (optional), default to now
//  dpuID for remote execution
//  cid, client ID filter (all if not specified, must be specified if iid is)
//  iid, instance ID filter (not used by default)
//  sync, 1 if getting securesying status, 0 (default) to get backup status.
//
//  Returns: XML structure of each day specified in input, either all clients
//  if no cid specified, or client only if cid specified.  If iid specified, only
//  the backups for that instance id are returned.
//
$endTime = isset($_GET['end']) ? (int)$_GET['end'] : time();
$intervals = generateIntervals($days, $endTime);
$result = getStatusSummary($BP, $xml, $days, $intervals, $dpuID);

// If replicated/grand client view, we need to get the grandclient list, otherwise, get the client list.
$clients = $grandClientView ? $BP->get_grandclient_list($dpuID) : $BP->get_client_list($dpuID);
if ($result !== false) {
	$xml->push('root');
	$i = 0;
	foreach ($result as $day) {
		$startTime = $intervals[$i++]['start_time'];
		buildSummaryXML($xml, $clients, $startTime, $day);
	}
	$xml->pop(); // root
} else {
	$BP->buildResult($xml, false);
}
echo($xml->getXml());

$BP->destroyCookie();
?>