<?php
// defines BP, xml, action, cookie
require '../header.php';

$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {			
	case "replicationcapacity": 
			$app_id = isset($_GET['app_id']) ? (int) $_GET['app_id'] : -1;
			$instance_id = isset($_GET['instance_id']) ? (int) $_GET['instance_id'] : -1;
			
			$filter = array();
			if ($dpuID != -1 ) {
				$filter['system_id'] = $dpuID;
			}
			if ($cid != -1 ) {
				$filter['client_id'] = $cid;
			}
			if ($app_id != -1 ) {
				$filter['app_id'] = $app_id;
			}
			if ($instance_id != -1 ) {
				$filter['instance_id'] = $instance_id;
			}
			
			//
			// Loop through all systems.  Will be only one in the list for a DPU, multiple systems on a Vault.
			//
			$systems = $BP->get_system_list();
			
			$xml->push('root');
			$localID = $BP->get_local_system_id();
			$bVault = $BP->local_system_is_vault();
			
			$bManager = $BP->local_system_is_mgr();
			$bMDPU = isset($_GET['mdpu']) ? true : false;
			
			foreach ($systems as $systemID => $systemName) {
				if ($systemID == $dpuID || $dpuID == $localID) {
					// If this system is a vault and we are looking at this system, skip it and go to the next.
					if ($bVault && ($systemID == $localID)) {
						continue;
					}
					// If this system is a manager and we are not running on the MDPU node nor are
					// not looking at the selected system, skip it.
					if (!$bVault && $bManager && !$bMDPU && ($systemID != $dpuID)) {
						continue;
					}
						
					$filter['system_id'] = $systemID;
					$retentionInfo = $BP->get_grandclient_retention_info($filter);
					// If there is only system in the list, error out. Otherwise, continue and put the
					// error in the grid.
					if ($retentionInfo === false) {
						createErrorXML($xml, $BP, $systemName);
					} else {
						$grandClients = $BP->get_grandclient_list($systemID);
						
						$retentionSettings = array();
						foreach ($grandClients as $gcID=>$gc) {
							// if client id was passed in, only get retention settings for that particular client
							if ($cid!=-1 && $cid!=$gcID) {
								continue;
							}
							$settings = $BP->get_retention_settings(array('client_id' => $gcID), $localID);
							if ($settings !== false) {
								$retentionSettings = array_merge($retentionSettings, $settings);
							}
						}
						$oldestArray = getOldest($BP, $retentionSettings, $localID);
				
						foreach ($retentionSettings as $settingsKey=>$setting) {
							$instID = $setting["instance_id"];
							// add system ID to retention settings for later use
							if (!isset($setting["system_id"])) {
								$retentionSettings[$settingsKey]["system_id"] = $systemID;
							}
							foreach ($retentionInfo	as $retKey=>$retInfo) {	
								if ($retInfo["instance_id"]==$instID) {
									$retentionInfo[$retKey]["retention_min"] = $setting["retention_min"];
									$retentionInfo[$retKey]["retention_max"] = $setting["retention_max"];
									unset($retentionSettings[$settingsKey]);
									break;
								}
							}
						}
						
						if (isset($retentionSettings) && count($retentionSettings)>0) {
							$retentionInfo = array_merge($retentionSettings, $retentionInfo);
						}
						
						$retInfo = processRetentionInfo($retentionInfo);
						buildGrandClientRetentionXML($xml, $retInfo, $grandClients, $systemName, $oldestArray);
					}
				}
			}
			$xml->pop(); //root
			echo($xml->getXml());
			break;
			
	case "identities":	
			$result = $BP->get_replicated_identities($dpuID);
			$result = array();
			if ($result !== false) {
				getIdentitiesXML($xml, $result);
			} else {
				$BP->buildResult($xml, $result);
			}
			echo($xml->getXml());
			break;
} // end switch

	// matches up instances with each client
	function processRetentionInfo ($retentionInfo){
		$clients = array();
		foreach ($retentionInfo as $instance) {
			$clientID = $instance["client_id"];
			$clients[$clientID][] = $instance;
		}
		return $clients;
	}
	
/*			
      1 | file-level         | file-level
      2 | Exchange 2003      | Exchange
      3 | Exchange 2007      | Exchange
      4 | Exchange 2010      | Exchange
     21 | SQL Server 2005    | SQL Server
     22 | SQL Server 2008    | SQL Server
     23 | SQL Server 2008 R2 | SQL Server
     24 | SQL Server 2012    | SQL Server
     30 | Archive            | Archive
     40 | VMware             | VMware
     50 | Hyper-V 2008 R2    | Hyper-V
     51 | Hyper-V 2012       | Hyper-V
    100 | Oracle 11          | Oracle
    110 | SharePoint 2007    | SharePoint
    111 | SharePoint 2010    | SharePoint
     60 | System Metadata    | System Metadata
*/
	
	function buildGrandClientRetentionXML($xml, $retentionInfo, $grandClients, $systemName, $oldestArray, $showRoot = false) {
		if ($showRoot == true) $xml->push('root');
		
		$TOTAL_NODE 			= "Used";
		$FILE_LEVEL_NODE 		= "TotalMaster";
		$VMWARE_NODE			= "TotalVMware";
		$HYPERV_NODE			= "TotalHyperV";
		$ORACLE_NODE 			= "TotalOracle";
		$SHAREPOINT_NODE 		= "TotalSharePoint";
		$EXCHANGE_NODE 			= "TotalExchange";
		$SQL_NODE 				= "TotalSQL";
		$SERVICE_PROFILE_NODE	= "TotalServiceProfile";
		$ARCHIVE_NODE 			= "TotalArchive";
		$SYSTEMMETADATA_NODE 	= "TotalSystemMetadata";
		
		$TOTAL_FULL_NODE		= "TotalFull";
		$RETENTION_MIN_NODE		= "RetentionMin";
		$RETENTION_MAX_NODE		= "RetentionMax";
		$RETENTION_ACTUAL_NODE	= "RetentionActual";
		
		// add up the replicated sizes across apps
		$sizesModel = array($TOTAL_NODE => 0,
							$FILE_LEVEL_NODE => 0,
						    $EXCHANGE_NODE => 0,
						    $SQL_NODE => 0,
						    $ARCHIVE_NODE => 0,
						    $VMWARE_NODE => 0,
						    $HYPERV_NODE => 0,
						    $ORACLE_NODE => 0,
						    $SHAREPOINT_NODE => 0,
							$SERVICE_PROFILE_NODE => 0,
						    $SYSTEMMETADATA_NODE => 0);
		$totalSizes = $sizesModel;
		
		// Retention holds retention info for each grand client			
		$xml->push("Retention", array("Name" => $systemName));
			
		foreach ($retentionInfo as $clientID=>$instances) {
			$clientName = isset($grandClients[$clientID]) ? $grandClients[$clientID] : UNKNOWN_ELEMENT;
			
			$xml->push("Client", array("Name" => $clientName, "ID" => $clientID));
			$totalClientSizes = $sizesModel;
			
			foreach ($instances as $instance) {
			
				if (isset($instance['system_id'])) {
					$systemID = $instance['system_id'];
					//$xml->element("SystemID", $systemID);
				}
				$instanceID = isset($instance['instance_id']) ? $instance['instance_id'] : 0;
				
				$appName = "";
				if (isset($instance['app_name'])) {
					$appName = $instance['app_name'];
					//$xml->element("AppName", $appName);
				}
				$name = "";
				if (isset($instance['name'])) {
					$name = $instance['name'];
				}
				$appID = 0;
				if (isset($instance['app_id'])) {
					$appID = $instance['app_id'];
					//$xml->element("AppID", $appID);
				}
				$size = 0;
				if (isset($instance['mb_size'])) {
					$size = $instance['mb_size'];
					if ($size > 0) {
						// get size in GB
						$size = round($size/1000,2);
					}
					$totalClientSizes[$TOTAL_NODE] = $totalClientSizes[$TOTAL_NODE] + $size;
				}
				
				$retentionActual = isset($oldestArray[$instanceID]) ? $oldestArray[$instanceID] : 0;
				if (strlen(strstr($appName, "file-level"))>0) {
					$totalClientSizes[$FILE_LEVEL_NODE] = $totalClientSizes[$FILE_LEVEL_NODE] + $size;
				
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
				} 
				else if (strlen(strstr($appName, "Exchange"))>0) {
					$totalClientSizes[$EXCHANGE_NODE] = $totalClientSizes[$EXCHANGE_NODE] + $size;
					$instanceName = (strlen($name)>0) ? $name : UNKNOWN_ELEMENT;									
					$xml->push("Exchange", array("Instance" => $instanceName));
					$xml->element('Size', toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // Exchange
				} 
				else if (strlen(strstr($appName, "SQL"))>0) {
					$totalClientSizes[$SQL_NODE] = $totalClientSizes[$SQL_NODE] + $size;
					$split = explode("|", $name);
					$instanceName = isset($split[0]) ? $split[0] : UNKNOWN_ELEMENT;
					$databaseName = isset($split[1]) ? $split[1] : UNKNOWN_ELEMENT;										
					$xml->push("SQL", array("Instance" => $instanceName, "Database" => $databaseName));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // SQL
				}
				else if (strlen(strstr($appName, "Archive"))>0) {
					$totalClientSizes[$ARCHIVE_NODE] = $totalClientSizes[$ARCHIVE_NODE] + $size;
				} 
				else if (strlen(strstr($appName, "VMware"))>0) {
					$totalClientSizes[$VMWARE_NODE] = $totalClientSizes[$VMWARE_NODE] + $size;
					$split = explode("|", $name);
					$serverName = isset($split[0]) ? $split[0] : UNKNOWN_ELEMENT;
					$vmName = isset($split[1]) ? $split[1] : UNKNOWN_ELEMENT;
					$xml->push("VMware", array("Server" => $serverName, "VM" => $vmName));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // VMware
				}
				else if (strlen(strstr($appName, "Hyper-V"))>0) {
					$totalClientSizes[$HYPERV_NODE] = $totalClientSizes[$HYPERV_NODE] + $size;
					$split = explode("|", $name);
					$vmName = isset($split[0]) ? $split[0] : UNKNOWN_ELEMENT;
					$guid = isset($split[1]) ? $split[1] : UNKNOWN_ELEMENT;
					$xml->push("HyperV", array("VM" => $vmName, "guid" => $guid));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // HyperV
				}
				else if (strlen(strstr($appName, "Oracle"))>0) {
					$totalClientSizes[$ORACLE_NODE] = $totalClientSizes[$ORACLE_NODE] + $size;
					$databaseName = (strlen($name)>0) ? $name : UNKNOWN_ELEMENT;
					$xml->push("Oracle", array("Database" => $databaseName));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // Oracle
				}
				else if (strlen(strstr($appName, "SharePoint"))>0) {
					$totalClientSizes[$SHAREPOINT_NODE] = $totalClientSizes[$SHAREPOINT_NODE] + $size;
					$instanceName = (strlen($name)>0) ? $name : UNKNOWN_ELEMENT;
					$xml->push(SHAREPOINT, array("Instance" => $instanceName));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // SharePoint
				}
				else if (strlen(strstr($appName, "UCS Service Profile"))>0) {
					$totalClientSizes[$SERVICE_PROFILE_NODE] = $totalClientSizes[$SERVICE_PROFILE_NODE] + $size;
					$instanceName = (strlen($name)>0) ? $name : UNKNOWN_ELEMENT;
					$xml->push("UCS_Service_Profile", array("Instance" => $instanceName));
					$xml->element($TOTAL_FULL_NODE, toNumberString($size));
					if (isset($instance['retention_min'])) {
						$xml->element($RETENTION_MIN_NODE, $instance['retention_min']);
					}					
					if (isset($instance['retention_max'])) {
						$xml->element($RETENTION_MAX_NODE, $instance['retention_max']);
					}
					$xml->element($RETENTION_ACTUAL_NODE,  $retentionActual);
					$xml->pop(); // UCS_Service_Profile
				}
				else if (strlen(strstr($appName, "System Metadata"))>0) {
					$totalClientSizes[$SYSTEMMETADATA_NODE] = $totalClientSizes[$SYSTEMMETADATA_NODE] + $size;
				}
			}
			
			foreach ($totalClientSizes as $appType=>$totalSize) {
				$totalSizes[$appType] = $totalSizes[$appType] + $totalSize;
				$xml->element($appType, toNumberString($totalSize));		
			}
			
			$xml -> pop(); // client
		}

		foreach ($totalSizes as $appType=>$totalSize) {				
			$xml->element($appType, $totalSize);		
		}
		
		$xml->pop(); // Retention
		if ($showRoot == true) $xml->pop();
	}
	
	function getIdentitiesXML($xml, $identities, $showRoot = true, $tag = "ReplicationIdentities") {
		if ($showRoot == true) $xml->push('root');
		if ($tag != "") $xml->push($tag);
		
		foreach ($identities as $identity) {
			$xml->push('ReplicatedIdentity');
			
			if (isset($identity['identity'])) {
				$xml->element("Identity", $identity['identity']);
			}
			if (isset($identity['client_name'])) {
				$xml->element("ClientName", $identity['client_name']);
			}
			if (isset($identity['app_name'])) {
				$xml->element("AppName", $identity['app_name']);
			}
			if (isset($identity['name1'])) {
				$xml->element("Name1", $identity['name1']);
			}
			if (isset($identity['name2'])) {
				$xml->element("Name2", $identity['name2']);
			}
			if (isset($identity['name3'])) {
				$xml->element("Name3", $identity['name3']);
			}
			if (isset($identity['name4'])) {
				$xml->element("Name4", $identity['name4']);
			}
			
			$xml->pop(); //ReplicatedIdentity
		}
		
		if ($tag != "") $xml->pop();
		if ($showRoot == true) $xml->pop();
	}
  
	
	//
	// This function logs an error if we cannot retrieve retention info.
	function createErrorXML($xml, $BP, $systemName)
	{
	
		global $Log;
		$message = " Could not get replication capacity information for system: " . $systemName;
		$message = $BP->getError() . ":" . $message;
		$Log->writeError($message, true);
		
		$xml->push("Retention", array("Name" => $systemName));						
		$xml->element('Error', $BP->getError());
		$xml->pop(); // Retention
	}
	
	
// function below copied from configure/retention

//
// Gets the oldest backup for the instances specified in the settings array, and builds a return array.
// The return array is indexed by the instance ID of the instance, and the value is the days in days of the oldest backup.
//
function getOldest($BP, $settings, $dpuID) {

  $sep = "";
  $instances = "";
  $returnArray = array();
  foreach ($settings as $setting) {
	  $instances .= $sep . $setting['instance_id'];
	  $sep = ",";
  }
  $oldestArray = $BP->get_oldest_backup($instances, $dpuID);
  if ($oldestArray !== false) {
	  foreach ($oldestArray as $oldest) {
		  $startTime = $oldest['start_time'];
		  $now = time();
		  $days = ($now - $startTime) / 3600 / 24;
		  // Do not round up, or actual retention could appear slightly longer than it is.
		  // $returnArray[$oldest['instance_id']] = round($days);
		  $returnArray[$oldest['instance_id']] = floor($days);

	  }
  } else {
	  global $Log;
	  $Log->writeVariable('failure getting the oldest backup: ' . $BP->getError());
  }
  return $returnArray;
}
	

$BP->destroyCookie();
?>