<?php

class ReportView {
	
	function getSummary( $summaryArray, $showFIleCount = true ) {
		$rows = "";
		
		$totalBackups = 0;
		$totalFIles   = 0;
		$totalSize    = 0;
		
		$numRows = 0;
		
		foreach( $summaryArray as $summaryItem ) {
			$systemName = $summaryItem[ "source" ];
			$dataCount =  $summaryItem[ "sizeCount" ];
			$replicationCount =  $summaryItem[ "sourceCount" ];
			
			$fileCount =  isset( $summaryItem[ "fileCount" ] ) ? $summaryItem[ "fileCount" ] : 0;
			
			$totalBackups += $replicationCount;
			$totalFIles   += $fileCount;
			$totalSize    += $dataCount;
			
			$rows.= $showFIleCount ? $this->getActiveOrHistorySummaryRow( $systemName, $replicationCount, $fileCount, $dataCount ) : 
									 $this->getQueueSummaryRow( $systemName, $replicationCount, $dataCount );
			
			$numRows++;
		}
			
		return array( "rows" => $rows, "totalBackups"=>$totalBackups, "totalFiles"=>$totalFIles, "totalSize"=>$totalSize, "totalSources"=>$numRows );
	}
	
	function getActiveOrHistorySummaryRow( $summarySource, $summaryBackups, $summaryFIles, $summaryData ) {
		
		$historySummaryRow = " 		<tr style='text-align: center; background-color: #CFCFCF; text-align: center; color:#000000;'>
                                        <td >$summarySource</td>
                                        <td >$summaryBackups</td>
                                        <td >$summaryFIles</td>
                                        <td >$summaryData</td>
                                	</tr>";
		return $historySummaryRow;
	}
	
	function getQueueSummaryRow( $queueSummarySource, $queueSummaryBackups, $queueSummaryData ) {
		$summaryRow = "<tr style='text-align: center; background-color: #CFCFCF; text-align: center; color:#000000;'>
							<td >$queueSummarySource</td>
							<td >$queueSummaryBackups</td>
							<td >$queueSummaryData</td>
						</tr>";	
		return $summaryRow;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	function getHistoryRow( $dpuName, $clientName, $instanceName, $targetName, $backupType, $date, $elapsed, $numData, $numFiles, $encrypted, $isError = false, $replicationMessage = NULL, $isLast = false ) {
		
		global $activity;
		global $activities;
		global $shortActivities;

		$headerBGColor  = $isError ? "#EE9999" : "#E4E4E4";
		$headerTxtColor = $isError ? "#990000" : "#444444"; 
		
		$replicationMessageArea = "<tr style='color: #444444; padding: 3px; background-color: #F1F1F1; text-align: left;'>
								    <td colspan='6'>$activity Message</td>
					  			  </tr>
                                  <tr style='padding: 3px; background-color: white; text-align: center; color:#BB0000'>
                                    <td colspan='6' >$replicationMessage</td>
                                  </tr>";
		$replicationMessageArea = $replicationMessage != NULL && $replicationMessage != '' && $isError ? $replicationMessageArea : "";
		
		$rowBuffer = "				<tr>
                                    	<td colspan='6' style='background-color: #666666; padding:0px'>
                                        	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='2' />
                                        </td>
                                    </tr>";
		$rowBuffer = $isLast ? "" : $rowBuffer;
		
		$historyRow = "<!--  start history Row -->
                    	<tr>
               				<td align='center'>
                            	<table  width='714' cellpadding='5' cellspacing='4' border='1'  bgcolor='#bbbbbb'>
                                	<tr style='height: 35px; padding-left: 8px; background-color: #E4E4E4; text-align: left;'>
										<td colspan='6'>
                                        	<span style='color: #444444; padding: 5px; margin-left: 2px;'>
                                            	<b style='color:#000000'>$dpuName</b>  |  
                                                <b style='color:#000000'>$clientName</b>  |  
                                                <b style='color:#000000'>$instanceName</b>  --&gt; 

                                                <b style='color:#000000'>$targetName</b></span>
                                        </td>
			  						</tr>
                                 	<tr style='color: #444444; padding: 3px; background-color: #F1F1F1; text-align: center;'>
                                    	<td width='160'>Type</td>
                                        <td width='190'>Completed</td>
                                        <td width='70'>Elapsed</td>
                                        <td width='80'>MBs</td>
                                        <td>Files</td>
                                        <td width='60'>Encrypted</td>
                                    </tr>
                                    <tr style='padding: 3px; background-color: white; text-align: center;'>
                                        <td>$backupType</td>
                                        <td>$date</td>
                                        <td>$elapsed</td>
                                        <td>$numData</td>
                                        <td>$numFiles</td>
                                        <td>$encrypted</td>
			  						</tr>
									$replicationMessageArea
									$rowBuffer
								</table>
                            </td>
                    	</tr>
                        <!-- end History Row -->";
		return $historyRow;
	}
	
	
	
	function getHistoryTable( $summaryRows, $historySummaryTotalBackups, $historySummaryTotalFiles, $historySummaryTotalData, $historyRows ) {
		global $activity;
		global $activities;
		global $shortActivities;

		$historyTable = "
	<tr>
      	<td>
			<table cellpadding='0' cellspacing='0' border='0' align='center'>
				<tr>
					<td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
				</tr>
				<tr>
					<td width='720' valign='bottom' bgcolor='#666666'>
						<img class='image_fix' src='http://www.unitrends.com/images/notifications/top-grey.png' alt='History Area Top' title='History Area Top' width='720' height='17' />
					</td>
				</tr>
				<tr>
					<td width='720' valign='top' align='center' bgcolor='#666666'>
						<table width='716' cellpadding='0' cellspacing='0' border='0' align='center'>
							<tr>
								<td><h2 style='font-size: 24px; color: white; margin-top: 1px; margin-bottom: 10px; margin-left: 15px;'>Completed $activities</h2></td>
							</tr>
							<tr>
								<td align='center'>
									<table width='714' cellpadding='5' cellspacing='4' border='1'  style='color: #EFEFEF; text-align: center;'>
										<tr style='color: #EFEFEF; background-color: #333333; text-align: center;'>
											<td>$activity Sources</td>
											<td>Backups</td>
											<td>Files</td>
											<td>Data MBs </td>
										</tr>
										$summaryRows
										<!-- start Summary Total Row -->
										<tr style='background-color: #EFEFEF; text-align: center; color:#000000;'>
											<td style='background-color: #CFCFCF; text-align: right; padding-right: 5px; color: #444444;'>Activity Totals >></td>
											<td>$historySummaryTotalBackups</td>
											<td>$historySummaryTotalFiles</td>
											<td>$historySummaryTotalData</td>
										</tr>
										<!-- End Suppery Total Row-->
									</table>
								</td>
							</tr>
							<tr>
								<td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
							</tr>
							$historyRows
						</table>
				   </td>
				</tr>
				<tr>
					<td width='720' valign='top'>
						<img class='image_fix' src='http://www.unitrends.com/images/notifications/bottom-grey.png' alt='History Area Bottom' title='History Area Bottom' width='720' height='17' />
					</td>
				</tr>
			</table>
		</td>
    </tr>";
		return $historyTable;	
	}
	
	
	
	
	function getActiveRow( $dpuName, $clientName, $instanceName, $targetName, $backupType, $operationName, $startDate, $elapsedTime, $numData, $encrypted, $isLast = false) {
		
		$rowBuffer = "<tr>
						<td colspan='7' style='background-color: #666666; padding:0px'>
							<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='2' />
						</td>
					  </tr>";
		$rowBuffer = $isLast ? "" : $rowBuffer;
		
		$row = "			<!--  start Active Row -->
								<tr>
									<td align='center' style='background-color: #666666; padding:0px'>
										<table  width='714' cellpadding='5' cellspacing='4' border='1'  bgcolor='#bbbbbb'>
											<tr style='height: 35px; padding-left: 8px; background-color: #E4E4E4; text-align: left;'>
												<td colspan='6'>
													<span style='color: #444444; padding: 5px; margin-left: 2px;'>
														<b style='color:#000000'>$dpuName</b>  |  
														<b style='color:#000000'>$clientName</b>  |  
														<b style='color:#000000'>$instanceName</b>  --&gt; 
														<b style='color:#000000'>$targetName</b></span>
												</td>
											</tr>
											<tr style='color: #444444; padding: 3px; background-color: #F1F1F1; text-align: center;'>
												<td width='160'>Type</td>
												<td>Operation</td>
												<td width='190'>Started</td>
												<td width='70'>Elapsed</td>
												<td width='80'>MBs</td>
												<td width='60'>Encrypted</td>
											</tr>
											<tr style='padding: 3px; background-color: white; text-align: center;'>
												<td>$backupType</td>
												<td>$operationName</td>
												<td>$startDate</td>
												<td>$elapsedTime</td>
												<td>$numData</td>
												<td>$encrypted</td>
											</tr>
											$rowBuffer
										</table>
									</td>
								</tr>
								<!--  end Active Row -->";	
		return $row;
		
	}
		

	function getActiveTable( $numReplicating, $numSystems, $activeSummaryTotalBackups, $activeSummaryTotalData, $summaryRows, $activeRows ) {
        global $activity;
        global $shortActivities;

		$pluralReplications = intval( $numReplicating ) > 1 ? "s" : "";
		$pluralSystems = intval( $numSystems ) > 1 ? "s" : "";
		
		$activeTable = "
			<tr>
			   <td valign='middle'>
				<table cellpadding='0' cellspacing='0' border='0' align='center'>
					<tr>
						<td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
					</tr>
					<tr>
						<td width='720' valign='bottom' bgcolor='#666666'>
							<img class='image_fix' src='http://www.unitrends.com/images/notifications/top-grey.png' alt='Active Area Top' title='Active Area Top' width='720' height='17' />
						</td>
					</tr>
					<tr>
						<td width='720' valign='top' align='center' bgcolor='#666666'>
							<table width='716' cellpadding='0' cellspacing='0' border='0' align='center'>
								<tr>
									<td><h2 style='font-size: 24px; color: white; margin-top: 1px; margin-bottom: 10px; margin-left: 15px;'>Active $shortActivities</h2></td>
								</tr>
								<tr>
									<td><span style='margin-left: 20px; margin-bottom: 3px; font-size: 16px; color: #EFEFEF;'>Currently replicating $numReplicating item$pluralReplications from $numSystems System$pluralSystems</span></td>
								</tr>
								<tr>
									<td><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='6' /></td>
								</tr>
								<tr>
									<td align='center'>
										<table width='714' cellpadding='5' cellspacing='4' border='1'  style='color: #EFEFEF; text-align: center;'>
											<tr style='color: #EFEFEF; background-color: #333333; text-align: center;'>
												<td>$activity Sources</td>
												<td>Backups</td>
												<td>Data MBs </td>
											</tr>
											$summaryRows
											<tr style='background-color: #EFEFEF; text-align: center; color:#000000;'>
												<td style='background-color: #CFCFCF; text-align: right; padding-right: 5px; color: #444444;'>Activity Totals >></td>
												<td>$activeSummaryTotalBackups</td>
												<td>$activeSummaryTotalData</td>
											</tr>
										</table>
									</td>
								</tr>
								<tr>
									<td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
								</tr>
							</table>
					   </td>
					</tr>
					$activeRows
					<tr>
						<td width='720' valign='top'>
							<img class='image_fix' src='http://www.unitrends.com/images/notifications/bottom-grey.png' alt='Activew Area Bottom' title='History Area Bottom' width='720' height='17' />
						</td>
					</tr>
				</table>
			  </td>
			</tr>";
		return $activeTable;
	}
	
	
	
	
	function getQueueTable( $numReplicating, $numSystems, $queueSummaryTotalBackups, $queueSummaryTotalData, $queueSummaryRows, $queueRows ) {

        global $activity;
        global $shortActivities;

		$pluralReplications = intval( $numReplicating ) > 1 ? "s" : "";
		$pluralSystems = intval( $numSystems ) > 1 ? "s" : "";
		$queueTable = "
	<tr>
      <td valign='middle'>
        <table cellpadding='0' cellspacing='0' border='0' align='center'>
        	<tr>
            	<td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
            </tr>
			<tr>
				<td width='720' valign='bottom' bgcolor='#666666'>
               		<img class='image_fix' src='http://www.unitrends.com/images/notifications/top-grey.png' alt='Queue Area Top' title='Queue Area Top' width='720' height='17' />
                </td>
			</tr>
            <tr>
            	<td width='720' valign='top' align='center' bgcolor='#666666'>
                    <table width='716' cellpadding='0' cellspacing='0' border='0' align='center'>
                        <tr>
                            <td><h2 style='font-size: 24px; color: white; margin-top: 1px; margin-bottom: 10px; margin-left: 15px;'>Queued $shortActivities</h2></td>
                        </tr>
                        <tr>
                            <td><span style='margin-left: 20px; margin-bottom: 3px; font-size: 16px; color: #EFEFEF;'>Currently queued $numReplicating item$pluralReplications from $numSystems System$pluralSystems</span></td>
                        </tr>
                        <tr>
                            <td><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='6' /></td>
                        </tr>
                        <tr>
                            <td align='center'>
                            	<table width='714' cellpadding='5' cellspacing='4' border='1'  style='color: #EFEFEF; text-align: center;'>
                            		<tr style='color: #EFEFEF; background-color: #333333; text-align: center;'>
                                        <td>$activity Sources</td>
                                        <td>Backups</td>
                                        <td>Data MBs </td>
                                	</tr>
                                	$queueSummaryRows
                                    <tr style='background-color: #EFEFEF; text-align: center; color:#000000;'>
                                        <td style='background-color: #CFCFCF; text-align: right; padding-right: 5px; color: #444444;'>Activity Totals &gt;&gt;</td>
                                        <td>$queueSummaryTotalBackups</td>
                                        <td>$queueSummaryTotalData</td>
                                    </tr>
                            	</table>
                       		</td>
                    	</tr>
                        <tr>
                            <td ><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='5' /></td>
                        </tr>
						$queueRows
                   </table>
               </td>
            </tr>
            <tr>
				<td width='720' valign='top'>
                    <img class='image_fix' src='http://www.unitrends.com/images/notifications/bottom-grey.png' alt='Queue Area Bottom' title='Queue Area Bottom' width='720' height='17' />
                </td>
			</tr>
		</table>
      </td>
    </tr>";	
		
		return $queueTable;
	}
	
	function getQueueRow( $dpuName, $clientName, $instanceName, $targetName, $backupType, $date, $elapsed, $numData, $encrypted, $isError = false, $replicationMessage = NULL, $isLast = false) {

		global $activity;

		$headerBGColor  = $isError ? "#EE9999" : "#E4E4E4";
		$headerTxtColor = $isError ? "#990000" : "#444444"; 
		
		$replicationMessageArea = "<tr style='color: #444444; padding: 3px; background-color: #F1F1F1; text-align: left;'>
								    <td colspan='5'>$activity Message</td>
					  			  </tr>
                                  <tr style='padding: 3px; background-color: white; text-align: center; color:#BB0000'>
                                    <td colspan='5' >$replicationMessage</td>
                                  </tr>";
		$replicationMessageArea = $replicationMessage != NULL && $replicationMessage != '' && $isError ? $replicationMessageArea : "";
		
		$rowBuffer = "<tr>
						<td colspan='5' style='background-color: #666666; padding:0px'>
							<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='2' />
						</td>
					  </tr>";
		$rowBuffer = $isLast ? "" : $rowBuffer;
		
		$queueRow = "<tr>
               				<td align='center'>
                       			<table width='714' cellpadding='5' cellspacing='4' border='1'  bgcolor='#bbbbbb'>
									<tr style='height: 35px; padding-left: 8px; background-color: $headerBGColor; text-align: left;'>
			  							<td colspan='5'><span style='color: $headerTxtColor; padding: 5px; margin-left: 2px;'>
                                        					<b style='color:#000000'>$dpuName</b>  |  
                                                            <b style='color:#000000'>$clientName</b>  |  
                                                            <b style='color:#000000'>$instanceName</b>  --&gt; 
                                                            <b style='color:#000000'>$targetName</b>
                                                       </span>
                                        </td>
			  						</tr>
  								  <tr style='color: #444444; padding: 3px; background-color: #F1F1F1; text-align: center;'>
                                    <td width='160'>Type</td>
                                    <td width='190'>Backup Completed</td>
                                    <td width='70'>Elapsed</td>
                                    <td width='80'>MBs</td>
                                    <td width='60'>Encrypted</td>
                                  </tr>
                                  <tr style='padding: 3px; background-color: white; text-align: center;'>
                                    <td>$backupType</td>
                                    <td>$date</td>
                                    <td>$elapsed</td>
                                    <td>$numData</td>
                                    <td>$encrypted</td>
                                  </tr>
                                  $replicationMessageArea
                                  $rowBuffer
								</table> 
                            </td>
                    	</tr>";
		return $queueRow;	
	}
	
	function getCompoundPage( $systemName, $systemVersion, $historyTable, $activeTable, $queueTable, $assetTag, $runDate, $version, $comment = '' ) {

		global $activity;
		global $activities;
		global $shortActivities;
		global $referenceNote;

		$page = "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'
   'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml'>
<head>
	<meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
	<meta name='viewport' content='width=device-width, initial-scale=1.0'/>
	<title>$activity Activity Report</title>
	<style type='text/css'>
		/* Based on The MailChimp Reset INLINE: Yes. */  
		/* Client-specific Styles */
		#outlook a {padding:0;} /* Force Outlook to provide a 'view in browser' menu link. */
		body{width:100% !important; -webkit-text-size-adjust:100%; -ms-text-size-adjust:100%; margin:0; padding:0;} 
		/* Prevent Webkit and Windows Mobile platforms from changing default font sizes.*/ 
		.ExternalClass {width:100%;} /* Force Hotmail to display emails at full width */  
		.ExternalClass, .ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td, .ExternalClass div {line-height: 100%;}
		/* Forces Hotmail to display normal line spacing.  More on that: http://www.emailonacid.com/forum/viewthread/43/ */ 
		#backgroundTable {margin:0; padding:0; width:100% !important; line-height: 100% !important;}
		/* End reset */

		/* Some sensible defaults for images
		Bring inline: Yes. */
		img {outline:none; text-decoration:none; -ms-interpolation-mode: bicubic;} 
		a img {border:none;} 
		.image_fix {display:block;}

		/* Yahoo paragraph fix
		Bring inline: Yes. */
		p {margin: 1em 0;}

		/* Hotmail header color reset
		Bring inline: Yes. */
		/*h1, h2, h3, h4, h5, h6 {color: black !important;}*/

		a, h2 a, h3 a, h4 a, h5 a, h6 a {color: blue !important;}

		a:active, h2 a:active,  h3 a:active, h4 a:active, h5 a:active, h6 a:active {
		color: red !important; /* Preferably not the same color as the normal header link color.  There is limited support for psuedo classes in email clients, this was added just for good measure. */
		}

		a:visited, h2 a:visited,  h3 a:visited, h4 a:visited, h5 a:visited, h6 a:visited {
		color: purple !important; /* Preferably not the same color as the normal header link color. There is limited support for psuedo classes in email clients, this was added just for good measure. */
		}

		/* Outlook 07, 10 Padding issue fix
		Bring inline: No.*/
		table td {border-collapse: collapse;}

    /* Remove spacing around Outlook 07, 10 tables
    Bring inline: Yes */
    table { border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt; }

		/* Styling your links has become much simpler with the new Yahoo.  In fact, it falls in line with the main credo of styling in email and make sure to bring your styles inline.  Your link colors will be uniform across clients when brought inline.
		Bring inline: Yes. */
		a {color: #E00034;}

		/***************************************************
		****************************************************
		MOBILE TARGETING
		****************************************************
		***************************************************/
		@media only screen and (max-device-width: 480px) {
			/* Part one of controlling phone number linking for mobile. */
			a[href^='tel'], a[href^='sms'] {
						text-decoration: none;
						color: blue; /* or whatever your want */
						pointer-events: none;
						cursor: default;
					}

			.mobile_link a[href^='tel'], .mobile_link a[href^='sms'] {
						text-decoration: default;
						color: orange !important;
						pointer-events: auto;
						cursor: default;
					}

		}

		/* More Specific Targeting */

		@media only screen and (min-device-width: 768px) and (max-device-width: 1024px) {
		/* You guessed it, ipad (tablets, smaller screens, etc) */
			/* repeating for the ipad */
			a[href^='tel'], a[href^='sms'] {
						text-decoration: none;
						color: blue; /* or whatever your want */
						pointer-events: none;
						cursor: default;
					}

			.mobile_link a[href^='tel'], .mobile_link a[href^='sms'] {
						text-decoration: default;
						color: orange !important;
						pointer-events: auto;
						cursor: default;
					}
		}

		@media only screen and (-webkit-min-device-pixel-ratio: 2) {
		/* Put your iPhone 4g styles in here */ 
		}

		/* Android targeting */
		@media only screen and (-webkit-device-pixel-ratio:.75){
		/* Put CSS for low density (ldpi) Android layouts in here */
		}
		@media only screen and (-webkit-device-pixel-ratio:1){
		/* Put CSS for medium density (mdpi) Android layouts in here */
		}
		@media only screen and (-webkit-device-pixel-ratio:1.5){
		/* Put CSS for high density (hdpi) Android layouts in here */
		}
		/* end Android targeting */

	</style>

	<!-- Targeting Windows Mobile -->
	<!--[if IEMobile 7]>
	<style type='text/css'>
	
	</style>
	<![endif]-->   

	<!-- ***********************************************
	****************************************************
	END MOBILE TARGETING
	****************************************************
	************************************************ -->

	<!--[if gte mso 9]>
		<style>
		/* Target Outlook 2007 and 2010 */
		</style>
	<![endif]-->
</head>
<!-- 
$comment
-->
<body style=\"background-color: #EFEFEF; font-family: Calibri, Candara, Segoe, Segoe UI, Optima, Arial, sans-serif; letter-spacing: 1px; background-image:url('http://www.unitrends.com/templates/unitrends-homepage-bifurcated/images/main-content-bg.jpg');\">
<table cellpadding='0' cellspacing='0' border='0' id='backgroundTable'>
	<tr>
		<td valign='middle'> 
		<!-- Tables are the most common way to format your email consistently. Set your table widths inside cells and in most cases reset cellpadding, cellspacing, and border to zero. Use nested tables as a way to space effectively in your message. -->
		<table cellpadding='0' cellspacing='0' border='0' align='center'>
        	<tr>
            	<td colspan='3'><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='6' /></td>
            </tr>
			<tr>
				<td width='720' colspan='3' valign='bottom' bgcolor='#F7F7F7'>
               		<img class='image_fix' src='http://www.unitrends.com/images/notifications/white-top.png' alt='Title Area Top' title='Title Area Top' width='720' height='17' />
                </td>
			</tr>
            <tr>
            	<td width='15' bgcolor='#F7F7F7'>&nbsp;</td>
            	<td width='215' align='justify' valign='middle' bgcolor='#F7F7F7'><img class='image_fix' src='/ui/assets/images/unitrends-logo-black.png' alt='Unitrends Logo' title='unitrends Logo' width='198' height='22' />
                </td>
				<td width='490' valign='middle' bgcolor='#F7F7F7'>
                    <table width='490' cellpadding='0' cellspacing='0' border='0' align='center'>
                        <tr>
                            <td><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='10' /></td>
                        </tr>
                        <tr>
                            <td><h1 style='margin-top: 1px; margin-bottom: 1px; font-size: 32px; color: #E00034;}'>$activity Activity</h1></td>
                        </tr>
                        <tr>
                            <td><h3 style='font-size: 15px; color: #444444;'>System:  <em>$systemName</em> Version: <em>$systemVersion</em></h3></td>
                        </tr>
                        <tr>
                            <td><span class='replicationHeadTitle'>$activity Activity for the 24 hour period ending on <br/>$runDate </span></td>
                        </tr>
                        <tr>
                            <td><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='8' /></td>
                        </tr>
                    </table>
                 </td>
            </tr>
			<tr>
				<td width='720' colspan='3' valign='middle' bgcolor='#F7F7F7'>
					<h3 style='font-size: 15px;  margin-left:20px; margin-right:20px;' align='justify'>$referenceNote</h3>
				</td>			
			</tr>
            <tr>
				<td width='720' colspan='3' valign='top'>
                    <img class='image_fix' src='http://www.unitrends.com/images/notifications/bottom-white.png' alt='Title Area Bottom' title='Title Area Bottom' width='720' height='17' />
                </td>
			</tr>
		</table>
       </td>
      </tr>
        $historyTable
        $activeTable
    	$queueTable
      <tr>
       <td>
		<table cellpadding='0' cellspacing='0' border='0' align='center'>
        	<tr>
            	<td colspan='2'><img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='8' /></td>
            </tr>
			<tr>
				<td width='720' colspan='2' valign='bottom' bgcolor='#F7F7F7'>
               		<img class='image_fix' src='http://www.unitrends.com/images/notifications/white-top.png' alt='Title Area Top' title='Title Area Top' width='720' height='17' />
                </td>
			</tr>
            <tr>
            	<td width='520' bgcolor='#F7F7F7'>
                	<table width='480' cellpadding='0' cellspacing='0' align='left'>
                    	<tr>
                        	<td>
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='12' height='1' />
                            </td>
                        	<td>
                            	<h2 style='margin-top: 3px; margin-bottom: 3px; margin-left:3px; font-size: 24px; color: #E00034;'>System information</h2>
                            </td>
                    	</tr>
                    	<tr>
                        	<td>
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='12' height='1' />
                            </td>
                        	<td>
                                <ul>
                                    <li>
                                        <span>Asset Tag: </span>
                                        <span><em>$assetTag</em></span>
                                    </li>
                                    <li>
                                        <span>$activity Activity Report generated: </span>
                                        <br/>
                                        <span>&nbsp;&nbsp;&nbsp;<em>$runDate</em></span>
                                    </li>
                                    <li>
                                        <span>Software version: </span>
                                        <span><em>$version</em></span>
                                    </li>
                                </ul>
                            </td>
                        </tr>
                        <tr>
                        	<td>
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='12' height='1' />
                            </td>
                        	<td>
                            	<p>Additional resources are available at the following:</p>
                            </td>
                        </tr>
                        <tr>
                        	<td>
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='12' height='1' />
                            </td>
                        	<td>
                                <ul>
                                    <li><a href='http://www.unitrends.com/docs/user-guides/recovery-series-and-ueb-administrators-guide'>Manual</a></li>
                                    <li><a href='http://www.unitrends.com/support/search-knowledge-base'>Knowledge Base</a></li>
                                    <li><a href='http://www.unitrends.com/support/customer-care-center/video-tutorials.html'>Training Videos</a></li>
                                </ul>
                            </td>
                        </tr>
                	
                	</table>
                </td>
                <td width='200' bgcolor='#F7F7F7' align='left' valign='top'>
                	<table width='150' cellpadding='2' cellspacing='2' align='center'>
                    	<tr>
                        	<td colspan='3' align='right'>
                            	<span style='font-size: 12px; color: #666666; text-align: right;'> Connect with us.</span>
                            </td>
                        </tr>
                    	<tr style='padding-right:5'>
                        	<td width='54' >
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='58' height='1' />
                            </td>
                        	<td width='42' >
                            	<a href='http://community.spiceworks.com/pages/unitrends'>
                					<img class='image_fix'  src='http://www.unitrends.com/reports/spiceworks.jpg' border='0' alt='Spiceworks' width='42' height='42'/>
                				</a>
                            </td>
                            <td width='42' >
                            <a href='http://www.facebook.com/unitrends'>
                            	<img class='image_fix'  src='http://www.unitrends.com/reports/facebook.jpg' border='0' alt='Be our friends on Facebok' width='42' height='42'/>
                                </a>
                            </td>
                        </tr>
                        <tr style='padding-right:5px'>
                        	<td width='54' >
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='58' height='1' />
                            </td>
                        	<td width='42' >
                            	<a href='http://www.linkedin.com/company/25406?trk=tyah'>
                            		<img class='image_fix'  src='http://www.unitrends.com/reports/linkd-in.jpg' border='0' alt='Linked In' width='42' height='42'/>
                                </a>
                            </td>
                            <td width='42' >
                            	<a href='http://twitter.com/#!/@Unitrends'>
                                	<img class='image_fix'  src='http://www.unitrends.com/reports/twitter.jpg' border='0' alt='Twitter' width='42' height='42'/>
								</a>
                            </td>
                        </tr>
                        <tr style='padding-right:5px'>
                        	<td width='54' >
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='58' height='1' />
                            </td>
                        	<td width='42' >
                           		<a href='http://www.youtube.com/user/UnitrendsInc'>
                                	<img class='image_fix'  src='http://www.unitrends.com/reports/you-tube.jpg' border='0' alt='You Tube' width='42' height='42'/>
								</a>
                            </td>
                            <td>
                            	<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='42' height='42' />
                            </td>
                        </tr>
                	</table>
                </td>
            </tr>
            <tr>
            
				<td width='720' colspan='2' valign='top'>
                    <img class='image_fix' src='http://www.unitrends.com/images/notifications/bottom-white.png' alt='Title Area Bottom' title='Title Area Bottom' width='720' height='17' />
                </td>
			</tr>
			<tr>
            	<td colspan='2'>
					<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='12' />
				</td>
            </tr>
			<tr>
				<td align='center' colspan='2'>
					<a href='http://validator.w3.org/check?uri=referer'>
						<img src='http://www.w3.org/Icons/valid-xhtml10' alt='Valid XHTML 1.0 Transitional' height='31' width='88' />
					</a>
				</td>
			</tr>
			<tr>
            	<td colspan='2'>
					<img class='image_fix' src='http://www.unitrends.com/images/notifications/pixel.gif' alt='tinySpacer' title='tinySpacer' width='1' height='18' />
				</td>
            </tr>
		</table>
		</td>
	</tr>
</table>
<!-- End of wrapper table -->
</body>
</html>";	
		return $page;
	}
	
}



?>
