<?php

//
// returns the output of bp_get_backup_summary for the specified days and intervals.
//
function getStatusSummary($BP, $xml, $days, $intervals, $dpuID) {
	
	$cid = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
	$sync = isset($_GET['sync']) ? ($_GET['sync'] == '1') : false;
	
	$result_format = array();
	if (!is_array($intervals)) {
		$endTime = isset($_GET['end']) ? (int)$_GET['end'] : time();
		$intervals = generateIntervals($days, $endTime);
	}
	$result_format['intervals'] = $intervals;
	if ($cid != -1) {
		$result_format['client_id'] = $cid;
		global $grandClientView;
		global $localID;
		$result_format['grandclients'] = $grandClientView;
		if ($grandClientView) {
			$dpuID = $localID;
		}
	} else {
		$result_format['grandclients'] = false;
	}
	if (isset($_GET['iid'])) {
		$iid = (int)$_GET['iid'];
		$result_format['instance_id'] = $iid;
	}
	$result_format['sync_types'] = $sync;
	$result = $BP->get_backup_summary($result_format, $dpuID);
	return $result;
}

//
// Generates the intervals to be passed to bp_get_backup_summary, given a number of days.
//
function generateIntervals($totalDays, $endTime) {
	$intervals = array();
    $endDate = strtotime(date("Y-m-d", $endTime));
	for ($i = 0, $days = $totalDays - 1; $i < $totalDays; $i++, $days--) {
		$start = strtotime("-".$days." day", $endDate);
		$intervals[$i] = array("start_time" => $start);
		if ($i != 0) {
			$intervals[$i - 1]["end_time"] = $start - 1;
		}
	}
	$intervals[$totalDays - 1]["end_time"] = $endTime;
	return($intervals);
}

//
// builds the XML structure of the results of bp_get_backup_summary
//
function buildSummaryXML($xml, $clients, $startTime, $day) {
	$xml->push('Day', array('StartTime' => $startTime,
							'Date' => date('M d Y', $startTime)));
	foreach ($day as $client) {
		$xml->push('Client', array('Name' => $clients[$client['client_id']],
								   'ID' => $client['client_id']));
		if (isset($client['successes'])) {
			$xml->element('Successes', $client['successes']);
		}
		if (isset($client['warnings'])) {
			$xml->element('Warnings', $client['warnings']);
		}
		if (isset($client['failures'])) {
			$xml->element('Failures', $client['failures']);
		}
		if (isset($client['in_progress'])) {
			$xml->element('InProgress', $client['in_progress']);
		}
		if (isset($client['verify_successes'])) {
			$xml->element('VerifySuccesses', $client['verify_successes']);
		}
		if (isset($client['verify_failures'])) {
			$xml->element('VerifyFailures', $client['verify_failures']);
		}
		if (isset($client['verify_in_progress'])) {
			$xml->element('VerifyInProgress', $client['verify_in_progress']);
		}
		$xml->pop(); // client
	}
	$xml->pop(); // day
}

?>